<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Parsers/Cpp/Emulator.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Parsers/Cpp/Emulator.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Parsers/Cpp/Emulator.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2005 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">__docformat__ = <span class="py-string">'reStructuredText'</span></span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">import</span> sys, os, os.path, re, string, stat, tempfile</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.config <span class="py-keyword">import</span> version</span>
<a id="line12"></a><span class="lineno"> 12</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/TempFile.html">TempFile</a>:</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line">    <span class="py-comment"># Use tempfile.NamedTemporaryFile once we can rely on Python 2.4</span></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/TempFile.html#__init__">__init__</a>(self, suffix):</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">        self.name = tempfile.mktemp(suffix)</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">        self.file = open(self.name, <span class="py-string">'w'</span>)</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">        self.file.close()</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/TempFile.html#__del__">__del__</a>(self):</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">        os.unlink(self.name)</span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator.html#find_ms_compiler_info">find_ms_compiler_info</a>():</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">    <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="py-string">    Try to find a (C++) MSVC compiler.</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><span class="py-string">    Return tuple of include path list and macro dictionary.&quot;&quot;&quot;</span></span>
<a id="line31"></a><span class="lineno"> 31</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">    vc6 = (<span class="py-string">'SOFTWARE\\Microsoft\\DevStudio\\6.0\\Products\\Microsoft Visual C++'</span>, <span class="py-string">'ProductDir'</span>)</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">    vc7 = (<span class="py-string">'SOFTWARE\\Microsoft\\VisualStudio\\7.0'</span>, <span class="py-string">'InstallDir'</span>)</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">    vc71 = (<span class="py-string">'SOFTWARE\\Microsoft\\VisualStudio\\7.1'</span>, <span class="py-string">'InstallDir'</span>)</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">    vc8 = (<span class="py-string">'SOFTWARE\\Microsoft\\VisualStudio\\8.0'</span>, <span class="py-string">'InstallDir'</span>)</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">    vc9e = (<span class="py-string">'SOFTWARE\\Microsoft\\VCExpress\\9.0\\Setup\\VC'</span>, <span class="py-string">'ProductDir'</span>)</span>
<a id="line37"></a><span class="lineno"> 37</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">    vc6_macros =  [(<span class="py-string">'__uuidof(x)'</span>, <span class="py-string">'IID()'</span>),</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">                   (<span class="py-string">'__int64'</span>, <span class="py-string">'long long'</span>),</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">                   (<span class="py-string">'_MSC_VER'</span>, <span class="py-string">'1200'</span>),</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">                   (<span class="py-string">'_MSC_EXTENSIONS'</span>, <span class="py-string">''</span>),</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">                   (<span class="py-string">'_WIN32'</span>, <span class="py-string">''</span>),</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">                   (<span class="py-string">'_M_IX86'</span>, <span class="py-string">''</span>),</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">                   (<span class="py-string">'_WCHAR_T_DEFINED'</span>, <span class="py-string">''</span>),</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">                   (<span class="py-string">'_INTEGRAL_MAX_BITS'</span>, <span class="py-string">'64'</span>),</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">                   (<span class="py-string">'PASCAL'</span>, <span class="py-string">''</span>),</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">                   (<span class="py-string">'RPC_ENTRY'</span>, <span class="py-string">''</span>),</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">                   (<span class="py-string">'SHSTDAPI'</span>, <span class="py-string">'HRESULT'</span>),</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">                   (<span class="py-string">'SHSTDAPI_(x)'</span>, <span class="py-string">'x'</span>)]</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">    vc6_paths = [<span class="py-string">'Include'</span>]</span>
<a id="line51"></a><span class="lineno"> 51</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">    vc7_macros = [(<span class="py-string">'__forceinline'</span>, <span class="py-string">'__inline'</span>),</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">                  (<span class="py-string">'__uuidof(x)'</span>, <span class="py-string">'IID()'</span>),</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">                  (<span class="py-string">'__w64'</span>, <span class="py-string">''</span>),</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">                  (<span class="py-string">'__int64'</span>, <span class="py-string">'long long'</span>),</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">                  (<span class="py-string">'_MSC_VER'</span>, <span class="py-string">'1300'</span>),</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">                  (<span class="py-string">'_MSC_EXTENSIONS'</span>, <span class="py-string">''</span>),</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">                  (<span class="py-string">'_WIN32'</span>, <span class="py-string">''</span>),</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">                  (<span class="py-string">'_M_IX86'</span>, <span class="py-string">''</span>),</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">                  (<span class="py-string">'_WCHAR_T_DEFINED'</span>, <span class="py-string">''</span>),</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">                  (<span class="py-string">'_INTEGRAL_MAX_BITS'</span>, <span class="py-string">'64'</span>),</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">                  (<span class="py-string">'PASCAL'</span>, <span class="py-string">''</span>),</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">                  (<span class="py-string">'RPC_ENTRY'</span>, <span class="py-string">''</span>),</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">                  (<span class="py-string">'SHSTDAPI'</span>, <span class="py-string">'HRESULT'</span>),</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">                  (<span class="py-string">'SHSTDAPI_(x)'</span>, <span class="py-string">'x'</span>)]</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">    vc7_paths = [<span class="py-string">'..\\..\\Vc7\\Include'</span>,</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">                 <span class="py-string">'..\\..\\Vc7\\PlatformSDK\\Include'</span>]</span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">    vc71_macros = [(<span class="py-string">'__forceinline'</span>, <span class="py-string">'__inline'</span>),</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">                   (<span class="py-string">'__uuidof(x)'</span>, <span class="py-string">'IID()'</span>),</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">                   (<span class="py-string">'__w64'</span>, <span class="py-string">''</span>),</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">                   (<span class="py-string">'__int64'</span>, <span class="py-string">'long long'</span>),</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">                   (<span class="py-string">'_MSC_VER'</span>, <span class="py-string">'1310'</span>),</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">                   (<span class="py-string">'_MSC_EXTENSIONS'</span>, <span class="py-string">''</span>),</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">                   (<span class="py-string">'_WIN32'</span>, <span class="py-string">''</span>),</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">                   (<span class="py-string">'_M_IX86'</span>, <span class="py-string">''</span>),</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">                   (<span class="py-string">'_WCHAR_T_DEFINED'</span>, <span class="py-string">''</span>),</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">                   (<span class="py-string">'_INTEGRAL_MAX_BITS'</span>, <span class="py-string">'64'</span>),</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">                   (<span class="py-string">'PASCAL'</span>, <span class="py-string">''</span>),</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">                   (<span class="py-string">'RPC_ENTRY'</span>, <span class="py-string">''</span>),</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">                   (<span class="py-string">'SHSTDAPI'</span>, <span class="py-string">'HRESULT'</span>),</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">                   (<span class="py-string">'SHSTDAPI_(x)'</span>, <span class="py-string">'x'</span>)]</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">    vc71_paths = [<span class="py-string">'..\\..\\Vc7\\Include'</span>,</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">                  <span class="py-string">'..\\..\\Vc7\\PlatformSDK\\Include'</span>]</span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">    vc8_macros = [(<span class="py-string">'__cplusplus'</span>, <span class="py-string">'1'</span>),</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">                  (<span class="py-string">'__forceinline'</span>, <span class="py-string">'__inline'</span>),</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">                  (<span class="py-string">'__uuidof(x)'</span>, <span class="py-string">'IID()'</span>),</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">                  (<span class="py-string">'__w64'</span>, <span class="py-string">''</span>),</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">                  (<span class="py-string">'__int8'</span>, <span class="py-string">'char'</span>),</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">                  (<span class="py-string">'__int16'</span>, <span class="py-string">'short'</span>),</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">                  (<span class="py-string">'__int32'</span>, <span class="py-string">'int'</span>),</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">                  (<span class="py-string">'__int64'</span>, <span class="py-string">'long long'</span>),</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">                  (<span class="py-string">'__ptr64'</span>, <span class="py-string">''</span>),</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">                  (<span class="py-string">'_MSC_VER'</span>, <span class="py-string">'1400'</span>),</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">                  (<span class="py-string">'_MSC_EXTENSIONS'</span>, <span class="py-string">''</span>),</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">                  (<span class="py-string">'_WIN32'</span>, <span class="py-string">''</span>),</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">                  (<span class="py-string">'_M_IX86'</span>, <span class="py-string">''</span>),</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">                  (<span class="py-string">'_WCHAR_T_DEFINED'</span>, <span class="py-string">''</span>),</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">                  (<span class="py-string">'_INTEGRAL_MAX_BITS'</span>, <span class="py-string">'64'</span>),</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">                  (<span class="py-string">'PASCAL'</span>, <span class="py-string">''</span>),</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">                  (<span class="py-string">'RPC_ENTRY'</span>, <span class="py-string">''</span>),</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">                  (<span class="py-string">'SHSTDAPI'</span>, <span class="py-string">'HRESULT'</span>),</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">                  (<span class="py-string">'SHSTDAPI_(x)'</span>, <span class="py-string">'x'</span>)]</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">    vc8_paths = [<span class="py-string">'..\\..\\Vc\\Include'</span>,</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">                 <span class="py-string">'..\\..\\Vc\\PlatformSDK\\Include'</span>]</span>
<a id="line107"></a><span class="lineno">107</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">    vc9e_macros = [(<span class="py-string">'__cplusplus'</span>, <span class="py-string">'1'</span>),</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">                  (<span class="py-string">'__forceinline'</span>, <span class="py-string">'__inline'</span>),</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">                  (<span class="py-string">'__uuidof(x)'</span>, <span class="py-string">'IID()'</span>),</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">                  (<span class="py-string">'__w64'</span>, <span class="py-string">''</span>),</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">                  (<span class="py-string">'__int8'</span>, <span class="py-string">'char'</span>),</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">                  (<span class="py-string">'__int16'</span>, <span class="py-string">'short'</span>),</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">                  (<span class="py-string">'__int32'</span>, <span class="py-string">'int'</span>),</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">                  (<span class="py-string">'__int64'</span>, <span class="py-string">'long long'</span>),</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">                  (<span class="py-string">'__ptr64'</span>, <span class="py-string">''</span>),</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">                  (<span class="py-string">'_MSC_VER'</span>, <span class="py-string">'1400'</span>),</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">                  (<span class="py-string">'_MSC_EXTENSIONS'</span>, <span class="py-string">''</span>),</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">                  (<span class="py-string">'_WIN32'</span>, <span class="py-string">''</span>),</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">                  (<span class="py-string">'_M_IX86'</span>, <span class="py-string">''</span>),</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">                  (<span class="py-string">'_WCHAR_T_DEFINED'</span>, <span class="py-string">''</span>),</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">                  (<span class="py-string">'_INTEGRAL_MAX_BITS'</span>, <span class="py-string">'64'</span>),</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">                  (<span class="py-string">'PASCAL'</span>, <span class="py-string">''</span>),</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">                  (<span class="py-string">'RPC_ENTRY'</span>, <span class="py-string">''</span>),</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">                  (<span class="py-string">'SHSTDAPI'</span>, <span class="py-string">'HRESULT'</span>),</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">                  (<span class="py-string">'SHSTDAPI_(x)'</span>, <span class="py-string">'x'</span>)]</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">    vc9e_paths = [<span class="py-string">'..\\..\\Vc\\Include'</span>,</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">                 <span class="py-string">'..\\..\\Vc\\PlatformSDK\\Include'</span>]</span>
<a id="line129"></a><span class="lineno">129</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">    compilers = [(vc9e, vc9e_macros, vc9e_paths),</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">                 (vc8, vc8_macros, vc8_paths),</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">                 (vc71, vc71_macros, vc71_paths),</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">                 (vc7, vc7_macros, vc7_paths),</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">                 (vc6, vc6_macros, vc6_paths)]</span>
<a id="line135"></a><span class="lineno">135</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">    found, paths, macros = False, [], []</span>
<a id="line137"></a><span class="lineno">137</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">    <span class="py-keyword">import</span> _winreg</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">    <span class="py-keyword">for</span> c <span class="py-keyword">in</span> compilers:</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">        <span class="py-keyword">try</span>:</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">            key = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, c[0][0])</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">            path, type = _winreg.QueryValueEx(key, c[0][1])</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">     found = True</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">            paths.extend([os.path.join(str(path), p) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> c[2]])</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">            macros.extend(c[1])</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">            <span class="py-keyword">break</span></span>
<a id="line147"></a><span class="lineno">147</span><span class="line">        <span class="py-keyword">except</span>:</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">            <span class="py-keyword">continue</span></span>
<a id="line149"></a><span class="lineno">149</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">    <span class="py-keyword">return</span> found, paths, macros</span>
<a id="line151"></a><span class="lineno">151</span>
<a id="line152"></a><span class="lineno">152</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator.html#find_gcc_compiler_info">find_gcc_compiler_info</a>(language, compiler, flags):</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">    <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line154"></a><span class="lineno">154</span><span class="line"><span class="py-string">    Try to find a GCC-based C or C++ compiler.</span></span>
<a id="line155"></a><span class="lineno">155</span><span class="line"><span class="py-string">    Return tuple of include path list and macro dictionary.&quot;&quot;&quot;</span></span>
<a id="line156"></a><span class="lineno">156</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">    found, paths, macros = False, [], []</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">    flags = <span class="py-string">' '</span>.join(flags)</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">    temp = TempFile(language == <span class="py-string">'C++'</span> <span class="py-keyword">and</span> <span class="py-string">'.cc'</span> <span class="py-keyword">or</span> <span class="py-string">'.c'</span>)</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">    <span class="py-comment"># The output below assumes the en_US locale, so make sure we use that.</span></span>
<a id="line161"></a><span class="lineno">161</span><span class="line">    command = <span class="py-string">'LANG=en_US %s %s -E -v -dD %s'</span>%(compiler, flags, temp.name)</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">    <span class="py-keyword">try</span>:</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">        <span class="py-keyword">import</span> subprocess <span class="py-comment"># available only since Python 2.4</span></span>
<a id="line164"></a><span class="lineno">164</span><span class="line">        p = subprocess.Popen(command, shell=True,</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">                             stdout=subprocess.PIPE,</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">                             stderr=subprocess.PIPE, close_fds=True)</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">        stdout, stderr = p.communicate()</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">        out, err = stdout.split(<span class="py-string">'\n'</span>), stderr.split(<span class="py-string">'\n'</span>)</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">    <span class="py-keyword">except</span>:</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">        stdin, stdout, stderr = os.popen3(command) <span class="py-comment"># for Python &lt; 2.4</span></span>
<a id="line171"></a><span class="lineno">171</span><span class="line">        out, err = stdout.readlines(), stderr.readlines()</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">        stdin.close()</span>
<a id="line173"></a><span class="lineno">173</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">    state = 0</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">    <span class="py-keyword">for</span> line <span class="py-keyword">in</span> err:</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">        line = line.rstrip()</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">        <span class="py-keyword">if</span> state == 0:</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">            <span class="py-keyword">if</span> line[:11] == <span class="py-string">'gcc version'</span>: state = 1</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">        <span class="py-keyword">elif</span> state == 1:</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">            state = 2</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">        <span class="py-keyword">elif</span> state == 2:</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">            <span class="py-keyword">if</span> line == <span class="py-string">'#include &lt;...&gt; search starts here:'</span>:</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">                state = 3</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">        <span class="py-keyword">elif</span> state == 3:</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">            <span class="py-keyword">if</span> line == <span class="py-string">'End of search list.'</span>:</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">                state = 4</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">                paths.append(line.strip())</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">    <span class="py-comment"># now read built-in macros</span></span>
<a id="line190"></a><span class="lineno">190</span><span class="line">    state = 0</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">    <span class="py-keyword">for</span> line <span class="py-keyword">in</span> out:</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">        line = line.rstrip()</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">        <span class="py-keyword">if</span> state == 0:</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">            <span class="py-keyword">if</span> line == <span class="py-string">'# 1 &quot;&lt;built-in&gt;&quot;'</span> <span class="py-keyword">or</span> line == <span class="py-string">'# 1 &quot;&lt;command line&gt;&quot;'</span>:</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">                state = 1</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">        <span class="py-keyword">elif</span> state == 1:</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">            <span class="py-keyword">if</span> line.startswith(<span class="py-string">'#define '</span>):</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">                tokens = line[8:].split(<span class="py-string">' '</span>, 1)</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">                <span class="py-keyword">if</span> len(tokens) == 1: tokens.append(<span class="py-string">''</span>)</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">                macros.append(tuple(tokens))</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">            <span class="py-keyword">elif</span> line == <span class="py-string">'# 1 &quot;%s&quot;'</span>%temp:</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">                state = 0</span>
<a id="line203"></a><span class="lineno">203</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">    <span class="py-comment"># Per-compiler adjustments</span></span>
<a id="line205"></a><span class="lineno">205</span><span class="line">    <span class="py-keyword">for</span> name, value <span class="py-keyword">in</span> tuple(macros):</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">        <span class="py-keyword">if</span> name == <span class="py-string">'__GNUC__'</span> <span class="py-keyword">and</span> value == <span class="py-string">'2'</span>:</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">            <span class="py-comment"># gcc 2.x needs this or it uses nonstandard syntax in the headers</span></span>
<a id="line208"></a><span class="lineno">208</span><span class="line">            macros.append((<span class="py-string">'__STRICT_ANSI__'</span>, <span class="py-string">''</span>))</span>
<a id="line209"></a><span class="lineno">209</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">    <span class="py-keyword">return</span> True, paths, macros</span>
<a id="line211"></a><span class="lineno">211</span>
<a id="line212"></a><span class="lineno">212</span>
<a id="line213"></a><span class="lineno">213</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator.html#find_compiler_info">find_compiler_info</a>(language, compiler, flags):</span>
<a id="line214"></a><span class="lineno">214</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">    found, paths, macros = False, [], []</span>
<a id="line216"></a><span class="lineno">216</span>
<a id="line217"></a><span class="lineno">217</span><span class="line">    <span class="py-keyword">if</span> compiler == <span class="py-string">'cl'</span> <span class="py-keyword">and</span> os.name == <span class="py-string">'nt'</span>:</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">        <span class="py-keyword">if</span> flags:</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">            sys.stderr.write(<span class="py-string">'Warning: ignoring unknown flags for MSVC compiler\n'</span>)</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">        found, paths, macros = find_ms_compiler_info()</span>
<a id="line221"></a><span class="lineno">221</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">    <span class="py-keyword">else</span>:</span>
<a id="line223"></a><span class="lineno">223</span><span class="line">        found, paths, macros = find_gcc_compiler_info(language, compiler, flags)</span>
<a id="line224"></a><span class="lineno">224</span>
<a id="line225"></a><span class="lineno">225</span><span class="line">    <span class="py-keyword">return</span> found, paths, macros</span>
<a id="line226"></a><span class="lineno">226</span>
<a id="line227"></a><span class="lineno">227</span>
<a id="line228"></a><span class="lineno">228</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator.html#get_compiler_timestamp">get_compiler_timestamp</a>(compiler):</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Returns the timestamp for the given compiler, or 0 if not found&quot;&quot;&quot;</span></span>
<a id="line230"></a><span class="lineno">230</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">    path = os.getenv(<span class="py-string">'PATH'</span>, os.defpath)</span>
<a id="line232"></a><span class="lineno">232</span><span class="line">    path = string.split(path, os.pathsep)</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">    <span class="py-keyword">for</span> directory <span class="py-keyword">in</span> path:</span>
<a id="line234"></a><span class="lineno">234</span><span class="line">        <span class="py-comment"># Try to stat the compiler in this directory, if it exists</span></span>
<a id="line235"></a><span class="lineno">235</span><span class="line">        filename = os.path.join(directory, compiler)</span>
<a id="line236"></a><span class="lineno">236</span><span class="line">        <span class="py-keyword">if</span> os.name == <span class="py-string">'nt'</span>: filename += <span class="py-string">'.exe'</span></span>
<a id="line237"></a><span class="lineno">237</span><span class="line">        <span class="py-keyword">try</span>: stats = os.stat(filename)</span>
<a id="line238"></a><span class="lineno">238</span><span class="line">        <span class="py-keyword">except</span> OSError: <span class="py-keyword">continue</span></span>
<a id="line239"></a><span class="lineno">239</span><span class="line">        <span class="py-keyword">return</span> stats[stat.ST_CTIME]</span>
<a id="line240"></a><span class="lineno">240</span><span class="line">    <span class="py-comment"># Not found</span></span>
<a id="line241"></a><span class="lineno">241</span><span class="line">    <span class="py-keyword">return</span> 0</span>
<a id="line242"></a><span class="lineno">242</span>
<a id="line243"></a><span class="lineno">243</span>
<a id="line244"></a><span class="lineno">244</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/CompilerInfo.html">CompilerInfo</a>:</span>
<a id="line245"></a><span class="lineno">245</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Info about one compiler.&quot;&quot;&quot;</span></span>
<a id="line246"></a><span class="lineno">246</span>
<a id="line247"></a><span class="lineno">247</span><span class="line">    compiler = <span class="py-string">''</span></span>
<a id="line248"></a><span class="lineno">248</span><span class="line">    <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line249"></a><span class="lineno">249</span><span class="line"><span class="py-string">    The name of the compiler, typically the executable name,</span></span>
<a id="line250"></a><span class="lineno">250</span><span class="line"><span class="py-string">    which must either be in the path or given as an absolute,</span></span>
<a id="line251"></a><span class="lineno">251</span><span class="line"><span class="py-string">    pathname.&quot;&quot;&quot;</span></span>
<a id="line252"></a><span class="lineno">252</span><span class="line">    flags = []</span>
<a id="line253"></a><span class="lineno">253</span><span class="line">    <span class="py-string">&quot;Compiler flags that impact its characteristics.&quot;</span></span>
<a id="line254"></a><span class="lineno">254</span><span class="line">    language = <span class="py-string">''</span></span>
<a id="line255"></a><span class="lineno">255</span><span class="line">    <span class="py-string">&quot;The programming language the compiler is used for.&quot;</span></span>
<a id="line256"></a><span class="lineno">256</span><span class="line">    kind = <span class="py-string">''</span></span>
<a id="line257"></a><span class="lineno">257</span><span class="line">    <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line258"></a><span class="lineno">258</span><span class="line"><span class="py-string">    A string indicating the type of this info:</span></span>
<a id="line259"></a><span class="lineno">259</span><span class="line"><span class="py-string">    one of 'system', 'custom', ''.</span></span>
<a id="line260"></a><span class="lineno">260</span><span class="line"><span class="py-string">    'custom' compilers will never be automatically updated,</span></span>
<a id="line261"></a><span class="lineno">261</span><span class="line"><span class="py-string">    and an empty string indicates a failure to look up the </span></span>
<a id="line262"></a><span class="lineno">262</span><span class="line"><span class="py-string">    given compiler.&quot;&quot;&quot;</span></span>
<a id="line263"></a><span class="lineno">263</span><span class="line">    timestamp = <span class="py-string">''</span></span>
<a id="line264"></a><span class="lineno">264</span><span class="line">    <span class="py-string">&quot;The timestamp of the compiler binary.&quot;</span></span>
<a id="line265"></a><span class="lineno">265</span><span class="line">    include_paths = []</span>
<a id="line266"></a><span class="lineno">266</span><span class="line">    <span class="py-string">&quot;A list of strings indicating the include paths.&quot;</span></span>
<a id="line267"></a><span class="lineno">267</span><span class="line">    macros = []</span>
<a id="line268"></a><span class="lineno">268</span><span class="line">    <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line269"></a><span class="lineno">269</span><span class="line"><span class="py-string">    A list of (name,value) pairs. Values may be empty, or None.</span></span>
<a id="line270"></a><span class="lineno">270</span><span class="line"><span class="py-string">    The latter ase indicates that the macro is to be undefined.&quot;&quot;&quot;</span></span>
<a id="line271"></a><span class="lineno">271</span>
<a id="line272"></a><span class="lineno">272</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/CompilerInfo.html#_write">_write</a>(self, os):</span>
<a id="line273"></a><span class="lineno">273</span><span class="line">        item = id(self) &gt;= 0 <span class="py-keyword">and</span> id(self) <span class="py-keyword">or</span> -id(self)</span>
<a id="line274"></a><span class="lineno">274</span><span class="line">        os.write(<span class="py-string">'class Item%u:\n'</span>%item)</span>
<a id="line275"></a><span class="lineno">275</span><span class="line">        <span class="py-keyword">for</span> name, value <span class="py-keyword">in</span> CompilerInfo.__dict__.iteritems():</span>
<a id="line276"></a><span class="lineno">276</span><span class="line">            <span class="py-keyword">if</span> name[0] != <span class="py-string">'_'</span>:</span>
<a id="line277"></a><span class="lineno">277</span><span class="line">                os.write(<span class="py-string">'    %s=%r\n'</span>%(name, getattr(self, name)))</span>
<a id="line278"></a><span class="lineno">278</span><span class="line">        os.write(<span class="py-string">'\n'</span>)</span>
<a id="line279"></a><span class="lineno">279</span>
<a id="line280"></a><span class="lineno">280</span>
<a id="line281"></a><span class="lineno">281</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/CompilerList.html">CompilerList</a>(object):</span>
<a id="line282"></a><span class="lineno">282</span>
<a id="line283"></a><span class="lineno">283</span><span class="line">    user_emulations_file = <span class="py-string">'~/.synopsis/parsers/cpp/emulator'</span></span>
<a id="line284"></a><span class="lineno">284</span><span class="line">    <span class="py-string">&quot;The cache file.&quot;</span></span>
<a id="line285"></a><span class="lineno">285</span>
<a id="line286"></a><span class="lineno">286</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/CompilerList.html#__init__">__init__</a>(self, filename = <span class="py-string">''</span>):</span>
<a id="line287"></a><span class="lineno">287</span>
<a id="line288"></a><span class="lineno">288</span><span class="line">        self.compilers = []</span>
<a id="line289"></a><span class="lineno">289</span><span class="line">        self.no_cache = os.environ.has_key(<span class="py-string">'SYNOPSIS_NO_CACHE'</span>)</span>
<a id="line290"></a><span class="lineno">290</span><span class="line">        self.load(filename)</span>
<a id="line291"></a><span class="lineno">291</span>
<a id="line292"></a><span class="lineno">292</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/CompilerList.html#list">list</a>(self):</span>
<a id="line293"></a><span class="lineno">293</span>
<a id="line294"></a><span class="lineno">294</span><span class="line">        <span class="py-keyword">return</span> [c.compiler <span class="py-keyword">for</span> c <span class="py-keyword">in</span> self.compilers]</span>
<a id="line295"></a><span class="lineno">295</span>
<a id="line296"></a><span class="lineno">296</span>
<a id="line297"></a><span class="lineno">297</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/CompilerList.html#_query">_query</a>(self, language, compiler, flags):</span>
<a id="line298"></a><span class="lineno">298</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Construct and return a CompilerInfo object for the given compiler.&quot;&quot;&quot;</span></span>
<a id="line299"></a><span class="lineno">299</span>
<a id="line300"></a><span class="lineno">300</span><span class="line">        ci = CompilerInfo()</span>
<a id="line301"></a><span class="lineno">301</span><span class="line">        ci.compiler = compiler</span>
<a id="line302"></a><span class="lineno">302</span><span class="line">        ci.flags = flags</span>
<a id="line303"></a><span class="lineno">303</span><span class="line">        ci.language = language</span>
<a id="line304"></a><span class="lineno">304</span><span class="line">        <span class="py-keyword">try</span>:</span>
<a id="line305"></a><span class="lineno">305</span><span class="line">            found, paths, macros = find_compiler_info(language, compiler, flags)</span>
<a id="line306"></a><span class="lineno">306</span><span class="line">            <span class="py-keyword">if</span> found:</span>
<a id="line307"></a><span class="lineno">307</span><span class="line">                ci.kind = <span class="py-string">'system'</span></span>
<a id="line308"></a><span class="lineno">308</span><span class="line">                ci.timestamp = get_compiler_timestamp(compiler)</span>
<a id="line309"></a><span class="lineno">309</span><span class="line">                ci.include_paths = paths</span>
<a id="line310"></a><span class="lineno">310</span><span class="line">                ci.macros = macros</span>
<a id="line311"></a><span class="lineno">311</span><span class="line">        <span class="py-keyword">except</span>:</span>
<a id="line312"></a><span class="lineno">312</span><span class="line">            ci.kind = <span class="py-string">''</span> <span class="py-comment"># failure</span></span>
<a id="line313"></a><span class="lineno">313</span><span class="line">            ci.timestamp = 0</span>
<a id="line314"></a><span class="lineno">314</span><span class="line">            ci.include_paths = []</span>
<a id="line315"></a><span class="lineno">315</span><span class="line">            ci.macros = []</span>
<a id="line316"></a><span class="lineno">316</span><span class="line">        <span class="py-keyword">return</span> ci</span>
<a id="line317"></a><span class="lineno">317</span>
<a id="line318"></a><span class="lineno">318</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/CompilerList.html#add_default_compilers">add_default_compilers</a>(self):</span>
<a id="line319"></a><span class="lineno">319</span>
<a id="line320"></a><span class="lineno">320</span><span class="line">        self.compilers.append(self._query(<span class="py-string">'C++'</span>, <span class="py-string">'c++'</span>, []))</span>
<a id="line321"></a><span class="lineno">321</span><span class="line">        self.compilers.append(self._query(<span class="py-string">'C++'</span>, <span class="py-string">'g++'</span>, []))</span>
<a id="line322"></a><span class="lineno">322</span><span class="line">        self.compilers.append(self._query(<span class="py-string">'C'</span>, <span class="py-string">'cc'</span>, []))</span>
<a id="line323"></a><span class="lineno">323</span><span class="line">        self.compilers.append(self._query(<span class="py-string">'C'</span>, <span class="py-string">'gcc'</span>, []))</span>
<a id="line324"></a><span class="lineno">324</span>
<a id="line325"></a><span class="lineno">325</span>
<a id="line326"></a><span class="lineno">326</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/CompilerList.html#load">load</a>(self, filename = <span class="py-string">''</span>):</span>
<a id="line327"></a><span class="lineno">327</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Loads the compiler infos from a file.&quot;&quot;&quot;</span></span>
<a id="line328"></a><span class="lineno">328</span>
<a id="line329"></a><span class="lineno">329</span><span class="line">        <span class="py-keyword">if</span> self.no_cache:</span>
<a id="line330"></a><span class="lineno">330</span><span class="line">            self.add_default_compilers()</span>
<a id="line331"></a><span class="lineno">331</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line332"></a><span class="lineno">332</span>
<a id="line333"></a><span class="lineno">333</span><span class="line">        compilers = []</span>
<a id="line334"></a><span class="lineno">334</span>
<a id="line335"></a><span class="lineno">335</span><span class="line">        glob = {}</span>
<a id="line336"></a><span class="lineno">336</span><span class="line">        glob[<span class="py-string">'version'</span>] = version</span>
<a id="line337"></a><span class="lineno">337</span><span class="line">        <span class="py-keyword">class</span> Type(type):</span>
<a id="line338"></a><span class="lineno">338</span><span class="line">            <span class="py-string">&quot;&quot;&quot;Factory for CompilerInfo objects.</span></span>
<a id="line339"></a><span class="lineno">339</span><span class="line"><span class="py-string">            This is used to read in an emulation file.&quot;&quot;&quot;</span></span>
<a id="line340"></a><span class="lineno">340</span>
<a id="line341"></a><span class="lineno">341</span><span class="line">            <span class="py-keyword">def</span> __init__(cls, name, bases, dict):</span>
<a id="line342"></a><span class="lineno">342</span>
<a id="line343"></a><span class="lineno">343</span><span class="line">                <span class="py-keyword">if</span> glob[<span class="py-string">'version'</span>] == version:</span>
<a id="line344"></a><span class="lineno">344</span><span class="line">                    compiler = CompilerInfo()</span>
<a id="line345"></a><span class="lineno">345</span><span class="line">                    <span class="py-keyword">for</span> name, value <span class="py-keyword">in</span> CompilerInfo.__dict__.items():</span>
<a id="line346"></a><span class="lineno">346</span><span class="line">                        <span class="py-keyword">if</span> name[0] != <span class="py-string">'_'</span>:</span>
<a id="line347"></a><span class="lineno">347</span><span class="line">                            setattr(compiler, name, dict.get(name, value))</span>
<a id="line348"></a><span class="lineno">348</span><span class="line">                    compilers.append(compiler)</span>
<a id="line349"></a><span class="lineno">349</span>
<a id="line350"></a><span class="lineno">350</span>
<a id="line351"></a><span class="lineno">351</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> filename:</span>
<a id="line352"></a><span class="lineno">352</span><span class="line">            filename = CompilerList.user_emulations_file</span>
<a id="line353"></a><span class="lineno">353</span><span class="line">        filename = os.path.expanduser(filename)</span>
<a id="line354"></a><span class="lineno">354</span><span class="line">        glob[<span class="py-string">'__builtins__'</span>] = __builtins__</span>
<a id="line355"></a><span class="lineno">355</span><span class="line">        glob[<span class="py-string">'__name__'</span>] = <span class="py-string">'__main__'</span></span>
<a id="line356"></a><span class="lineno">356</span><span class="line">        glob[<span class="py-string">'__metaclass__'</span>] = Type</span>
<a id="line357"></a><span class="lineno">357</span><span class="line">        <span class="py-keyword">try</span>:</span>
<a id="line358"></a><span class="lineno">358</span><span class="line">            execfile(filename, glob, glob)</span>
<a id="line359"></a><span class="lineno">359</span><span class="line">        <span class="py-keyword">except</span> IOError:</span>
<a id="line360"></a><span class="lineno">360</span>
<a id="line361"></a><span class="lineno">361</span><span class="line">            self.add_default_compilers()</span>
<a id="line362"></a><span class="lineno">362</span><span class="line">            self.save()</span>
<a id="line363"></a><span class="lineno">363</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line364"></a><span class="lineno">364</span><span class="line">            self.compilers = compilers</span>
<a id="line365"></a><span class="lineno">365</span>
<a id="line366"></a><span class="lineno">366</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/CompilerList.html#save">save</a>(self, filename = <span class="py-string">''</span>):</span>
<a id="line367"></a><span class="lineno">367</span>
<a id="line368"></a><span class="lineno">368</span><span class="line">        <span class="py-keyword">if</span> self.no_cache:</span>
<a id="line369"></a><span class="lineno">369</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line370"></a><span class="lineno">370</span>
<a id="line371"></a><span class="lineno">371</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> filename:</span>
<a id="line372"></a><span class="lineno">372</span><span class="line">            filename = CompilerList.user_emulations_file</span>
<a id="line373"></a><span class="lineno">373</span><span class="line">        filename = os.path.expanduser(filename)</span>
<a id="line374"></a><span class="lineno">374</span><span class="line">        dirname = os.path.dirname(filename)</span>
<a id="line375"></a><span class="lineno">375</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> os.path.exists(dirname):</span>
<a id="line376"></a><span class="lineno">376</span><span class="line">            os.makedirs(dirname)</span>
<a id="line377"></a><span class="lineno">377</span><span class="line">        emu = open(filename, <span class="py-string">'wt'</span>)</span>
<a id="line378"></a><span class="lineno">378</span><span class="line">        emu.write(<span class="py-string">&quot;&quot;&quot;# This file was generated by Synopsis.Parsers.Cpp.Emulator.</span></span>
<a id="line379"></a><span class="lineno">379</span><span class="line"><span class="py-string"># When making any manual modifications to any of the classes</span></span>
<a id="line380"></a><span class="lineno">380</span><span class="line"><span class="py-string"># be sure to set the 'kind' field to 'custom' so it doesn't get</span></span>
<a id="line381"></a><span class="lineno">381</span><span class="line"><span class="py-string"># accidentally overwritten !\n&quot;&quot;&quot;</span>)</span>
<a id="line382"></a><span class="lineno">382</span><span class="line">        emu.write(<span class="py-string">'\n'</span>)</span>
<a id="line383"></a><span class="lineno">383</span><span class="line">        emu.write(<span class="py-string">'version=%r\n'</span>%version)</span>
<a id="line384"></a><span class="lineno">384</span><span class="line">        emu.write(<span class="py-string">'\n'</span>)</span>
<a id="line385"></a><span class="lineno">385</span><span class="line">        <span class="py-keyword">for</span> c <span class="py-keyword">in</span> self.compilers:</span>
<a id="line386"></a><span class="lineno">386</span><span class="line">            c._write(emu)</span>
<a id="line387"></a><span class="lineno">387</span>
<a id="line388"></a><span class="lineno">388</span>
<a id="line389"></a><span class="lineno">389</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/CompilerList.html#refresh">refresh</a>(self):</span>
<a id="line390"></a><span class="lineno">390</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Refreshes the compiler list.</span></span>
<a id="line391"></a><span class="lineno">391</span><span class="line"><span class="py-string">        Regenerate all non-custom compilers without destroying custom</span></span>
<a id="line392"></a><span class="lineno">392</span><span class="line"><span class="py-string">        compilers.&quot;&quot;&quot;</span></span>
<a id="line393"></a><span class="lineno">393</span>
<a id="line394"></a><span class="lineno">394</span><span class="line">        compilers = []</span>
<a id="line395"></a><span class="lineno">395</span><span class="line">        <span class="py-keyword">for</span> ci <span class="py-keyword">in</span> self.compilers:</span>
<a id="line396"></a><span class="lineno">396</span><span class="line">            <span class="py-keyword">if</span> ci.is_custom:</span>
<a id="line397"></a><span class="lineno">397</span><span class="line">                compilers.append(ci)</span>
<a id="line398"></a><span class="lineno">398</span><span class="line">            ci = _query(ci.language, ci.compiler, ci.flags)</span>
<a id="line399"></a><span class="lineno">399</span><span class="line">            <span class="py-keyword">if</span> ci:</span>
<a id="line400"></a><span class="lineno">400</span><span class="line">                compilers.append(ci)</span>
<a id="line401"></a><span class="lineno">401</span>
<a id="line402"></a><span class="lineno">402</span><span class="line">        self.compilers = compilers</span>
<a id="line403"></a><span class="lineno">403</span><span class="line">        self.save()</span>
<a id="line404"></a><span class="lineno">404</span>
<a id="line405"></a><span class="lineno">405</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator/CompilerList.html#find">find</a>(self, language, compiler, flags):</span>
<a id="line406"></a><span class="lineno">406</span>
<a id="line407"></a><span class="lineno">407</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> flags:</span>
<a id="line408"></a><span class="lineno">408</span><span class="line">            flags = []</span>
<a id="line409"></a><span class="lineno">409</span><span class="line">        <span class="py-keyword">for</span> ci <span class="py-keyword">in</span> self.compilers:</span>
<a id="line410"></a><span class="lineno">410</span><span class="line">            <span class="py-keyword">if</span> (<span class="py-keyword">not</span> compiler <span class="py-keyword">and</span> language == ci.language</span>
<a id="line411"></a><span class="lineno">411</span><span class="line">                <span class="py-keyword">or</span> (compiler == ci.compiler <span class="py-keyword">and</span> flags == ci.flags)):</span>
<a id="line412"></a><span class="lineno">412</span><span class="line">                <span class="py-keyword">return</span> ci</span>
<a id="line413"></a><span class="lineno">413</span><span class="line">        ci = self._query(language, compiler, flags)</span>
<a id="line414"></a><span class="lineno">414</span><span class="line">        self.compilers.append(ci)</span>
<a id="line415"></a><span class="lineno">415</span><span class="line">        self.save()</span>
<a id="line416"></a><span class="lineno">416</span><span class="line">        <span class="py-keyword">return</span> ci</span>
<a id="line417"></a><span class="lineno">417</span>
<a id="line418"></a><span class="lineno">418</span>
<a id="line419"></a><span class="lineno">419</span><span class="line"><span class="py-comment"># Cache that makes multiple calls to 'get_compiler_info' more efficient.</span></span>
<a id="line420"></a><span class="lineno">420</span><span class="line">compiler_list = None</span>
<a id="line421"></a><span class="lineno">421</span>
<a id="line422"></a><span class="lineno">422</span>
<a id="line423"></a><span class="lineno">423</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Emulator.html#get_compiler_info">get_compiler_info</a>(language, compiler = <span class="py-string">''</span>, flags = None):</span>
<a id="line424"></a><span class="lineno">424</span><span class="line">    <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line425"></a><span class="lineno">425</span><span class="line"><span class="py-string">    Returns the compiler info for the given compiler. If none is</span></span>
<a id="line426"></a><span class="lineno">426</span><span class="line"><span class="py-string">    specified (''), return the first available one for the given language.</span></span>
<a id="line427"></a><span class="lineno">427</span><span class="line"><span class="py-string">    The info is returned as a CompilerInfo object, or None if the compiler</span></span>
<a id="line428"></a><span class="lineno">428</span><span class="line"><span class="py-string">    isn't found. </span></span>
<a id="line429"></a><span class="lineno">429</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line430"></a><span class="lineno">430</span><span class="line">    <span class="py-keyword">global</span> compiler_list</span>
<a id="line431"></a><span class="lineno">431</span>
<a id="line432"></a><span class="lineno">432</span><span class="line">    <span class="py-keyword">if</span> <span class="py-keyword">not</span> compiler_list:</span>
<a id="line433"></a><span class="lineno">433</span><span class="line">        compiler_list = CompilerList()</span>
<a id="line434"></a><span class="lineno">434</span>
<a id="line435"></a><span class="lineno">435</span><span class="line">    ci = compiler_list.find(language, compiler, flags)</span>
<a id="line436"></a><span class="lineno">436</span><span class="line">    <span class="py-keyword">return</span> ci</span>
<a id="line437"></a><span class="lineno">437</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:13 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
